<template>
	<v-row class="search-box " align="center" no-gutters >
		<v-col :cols="option.labelCols" class="py-0">
			<label for="" class="search-box-label">
				<v-icon
					v-if="iconShow"
					small
					:color="item.required ? '#fb8200' : 'primary'"
					:class="['mr-1', item.required ? 'icon-orange' : 'icon-blue']"
					>$icoBulletPoint</v-icon
				>
				{{ option.labelContent }}
			</label>
		</v-col>
		<v-col :cols="option.textCols">
			<!-- append-icon="mdi-magnify" -->
			<v-text-field
				readonly
				v-model="selectValue"
				class="v-input__custom"
				@click="dialogOpenCloseEvent(dialog)"
				outlined
				:hide-details="true"
			>
			<!-- Custom SVG icon -->
			<template v-slot:append>
				<v-icon>$icoSearch</v-icon>
			</template>
		</v-text-field>
		</v-col>

		<v-dialog v-model="dialog" scrollable width="700px">
			<v-card style="height: 100%">
				<v-card-title class="px-6 py-4 d-flex align-center justify-space-between">
					<span class="custom-title-4">{{ option.modalTitle }}</span>
					<a-button icon="close" type="text" @click="dialogOpenCloseEvent(dialog)"></a-button>
				</v-card-title>
				<div class="pa-5">
					<v-row align="center" no-gutters>
						<v-col :cols="12">
							<label for="" class="search-box-label">
								<!-- <v-icon x-small color="primary" class="mr-1">mdi-record-circle</v-icon> -->
								<v-icon small :class="['mr-1 icon-blue']">$icoBulletPoint</v-icon>
								검색
							</label>
						</v-col>
						<v-col :cols="9">
							<v-text-field
								append-icon="mdi-magnify"
								class="v-input__custom"
								outlined
								:hide-details="true"
								v-model="searchWord"
								@keyup.enter="search"
							></v-text-field>
						</v-col>
						<v-spacer></v-spacer>
						<v-col :cols="3" class="text-right">
							<a-button type="primary" @click="search()" icon="search">
								조회
							</a-button>
							<a-button @click="initSearch()">
								초기화
							</a-button>
						</v-col>
					</v-row>
				</div>
			<!-- <v-divider></v-divider> -->
				<div style="height: 429px;" class="py-3 px-5">
					<div ref="modalGridParent" class="h100 w100">
						<component
							:is="loadGrid && dialog ? 'Grid' : null"
							:gridName="grid_01"
							:dataPath="searchParam.modalData3.FtnPlcFormPop"
							:parentPrgmId="parentPrgmId"
							@getRowsData="getRowData"
							@dblClick="setUpdate($event)"
						/>
					</div>
				</div>
				<v-card-actions class="pa-5 d-flex align-center justify-end">
					<a-button class="mr-2" @click="dialogOpenCloseEvent(dialog)">닫기</a-button>
					<a-button type="primary" @click="setUpdate($event)">확인</a-button>
				</v-card-actions>
			</v-card>
		</v-dialog>
	</v-row>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';
import Grid from '~/components/common/Grid';
import Utility from '~/plugins/utility';

export default {
	props: {
		parentPrgmId: {
			type: String,
			require: true,
		},
		labelCols: {
			type: Number,
			require: false,
			default: 4,
		},
		labelContent: {
			type: String,
			require: false,
			default: '공정',
		},
		textCols: {
			type: Number,
			require: false,
			default: 7,
		},
		modalTitle: {
			type: String,
			require: false,
			default: '공정',
		},
		modalContent: {
			type: String,
			require: false,
			default: '검색',
		},
		item: {
			type: Object,
			require: false,
		},
		bindingData: {
			type: String,
			require: false,
		},
		iconShow: {
			type: Boolean,
			require: false,
			default: true
		},
	},
	components: {
		Grid,
		Utility,
	},
	data() {
		return {
			dialog: false,

			loadGrid: true,
			grid_01: 'grid_01',
			myModalKey: 'FtnPlcFormPop',
			modalDataKey: 'modalData3',

			searchWord: '',
			selectedData: {},
			textFieldData: '',

			option: {
				labelCols:
					this.item !== undefined
						? this.item.labelCols !== undefined
							? this.item.labelCols
							: this.labelCols
						: this.labelCols,
				labelContent:
					this.item !== undefined
						? this.item.labelContent !== undefined
							? this.item.labelContent
							: this.labelContent
						: this.labelContent,
				textCols:
					this.item !== undefined
						? this.item.textCols !== undefined
							? this.item.textCols
							: this.textCols
						: this.textCols,
				modalTitle:
					this.item !== undefined
						? this.item.modalTitle !== undefined
							? this.item.modalTitle
							: this.modalTitle
						: this.modalTitle,
			},
		};
	},
	computed: {
		...mapState({
			searchParam(state) {
				return state.pageData[this.parentPrgmId];
			},
			myBindingData(state) {
				if (!this.bindingData) {
					return state.pageData[this.parentPrgmId]['rowGridSelectData'];
				} else {
					return state.pageData[this.parentPrgmId][this.bindingData][
						'rowGridSelectData'
					];
				}
			},
		}),
		selectValue: {
			get() {
				if (!this.item) {
					return this.textFieldData;
				}
				// else if(this.item.disableContent){
				//   return "NONE";
				// }
				else {
					return this.myBindingData
						? this.myBindingData[this.item.valueNm]
						: this.textFieldData;
				}
			},
			set(value) {
				// if(this.item && this.item.disableContent){
				//   return "NONE";
				// }
				return value;
			},
		},
	},
	watch: {
		async dialog(val) {
			if (val) {
				await this.getGridData();
			}
		},
	},

	beforeCreate() {
		this.$store.commit('setPageData', {
			modalData3: { FtnPlcFormPop },
		});
	},
	created() {
		this.init();
	},
	mounted() {},
	methods: {
		...mapMutations({
			setPageData: 'setPageData',
			setModalGridData: 'setModalGridData',
			setModalGridColumn: 'setModalGridColumn',
			setModalGridOption: 'setModalGridOption',
		}),
		...mapActions({
			postApiReturn: 'modules/list/postApiReturn',
			setTree: 'modules/list/setTree',
		}),
		init() {
			this.gridInit();
		},
		search() {
			this.getGridData();
		},
		initSearch() {
			this.searchWord = '';
			this.getGridData();
		},
		gridInit() {
			let myOptions = {
				treeColumnOptions: {
					name: 'eccNm',
					useIcon: true,
				},
				scrollX: false,
			};
			this.setModalGridOption({
				modalKey: this.myModalKey,
				gridKey: this.grid_01,
				modalDataKey: this.modalDataKey,
				value: Object.assign(
					// Utility.defaultGridOption(this.$refs.modalGridParent.offsetHeight - 60, myOptions),
					Utility.defaultGridOption(390, myOptions),
					myOptions,
				),
			});

			this.setModalGridColumn({
				modalKey: this.myModalKey,
				gridKey: this.grid_01,
				modalDataKey: this.modalDataKey,
				value: [
					{
						align: 'center',
						width: 30,
						minWidth: 60,
						formatter: (props) => {
							return `<span class="custom-radio"><span class="radio-mark"></span></span>`;
						}
					},
					{ header: '위치정보', name: 'eccNm' }
				],
			});
		},
		async getGridData() {
			this.loadGrid = false;

			const res = await this.postApiReturn({
				apiKey: 'selectEccBaseInfo',
				resKey: 'eccBaseInfoData',
				sendParam: {
					blocId: this.myBindingData.blocId,
					eqpmYn: '0',
					search: this.searchWord,
				},
			});

			const setTreeData = await this.setTree({
				gridKey: this.gridNameTree,
				treeKey: 'ECC_ID',
				value: res.map(item => ({
					...item,
					eccNm: item.eccNm,
				})),
			});

			this.setModalGridData({
				modalKey: this.myModalKey,
				gridKey: this.grid_01,
				modalDataKey: this.modalDataKey,
				value: setTreeData.ROOT,
			});

			this.loadGrid = true;
		},
		getRowData(data) {
			this.selectedData = { ...data };
		},
		setUpdate(v) {
			this.dialog = false;

			const dt = {
				columnName: this.item.valueNm,
				value: this.selectedData['eccId'],
			};

			const dt2 = {
				columnName: this.item.valueNm2,
				value: this.selectedData['eccNm'],
			};
			if (!this.item.eccFgYn) {
				this.myBindingData.upEccNm = this.selectedData.eccNm;
				this.myBindingData.upEccId = this.selectedData.eccId;
				this.$emit('gridEditingFinish', dt);
				this.$emit('gridEditingFinish', dt2);
			} else {
				if (this.selectedData.eccFg == '1') {
					this.myBindingData.upEccNm = this.selectedData.eccNm;
					this.myBindingData.upEccId = this.selectedData.eccId;
					this.$emit('gridEditingFinish', dt);
					this.$emit('gridEditingFinish', dt2);
				} else {
					alert('공정(ECC)을 선택해주세요.');
					return false;
				}
			}
		},
		dialogOpenCloseEvent(val) {
			this.dialog = !val;
		},
	},
};

var FtnPlcFormPop = {
	grid_01: {
		data: [],
		column: [],
		option: {},
	},
};
</script>

<style lang="scss" scoped>
// @each $theme in dark, light {
// 	@include theme($theme);
// 	.v-application.#{$theme}-mode {
// 		.v-input--is-readonly {
// 			border-color: map-deep-get($config,
// 				#{$theme},
// 				"v-input-readonly-border-color"
// 			);
// 			::v-deep {
// 				&:not(.v-input--radio-group, .v-input--checkbox) {
// 					.v-input__slot {
// 						background-color: map-deep-get($config,
// 							#{$theme},
// 							"v-input-backgroundColor"
// 						) !important;
// 					}
// 				}
// 			}

// 		}
// 	}
// }

::v-deep {

	.v-dialog {
		overflow-y: hidden !important;
	}

	.tui-grid-table-container {
		.tui-grid-table {
			border-right-style: solid !important;
			border-right-color: rgba(255, 255, 255, 0.1) !important;
		}
	}

	.tui-grid-cell.tui-grid-cell-has-tree
		.tui-grid-tree-extra-content
		+ .tui-grid-cell-content:before {
		content: none !important;
	}

	.tui-grid-tree-icon {
		margin-left: -21px !important;
	}
}

</style>
